------------------------------------------------------------------------------
-- "standard_additions" package contains the additions to the built in
-- "standard.std" package.  In the final version this package will be implicit.
--  Created for VHDL-200X par, David Bishop (dbishop@vhdl.org)
------------------------------------------------------------------------------
package standard_additions is

--  function "?=" (anonymous, anonymous  : BOOLEAN) return BOOLEAN;
--  function "?/=" (anonymous, anonymous : BOOLEAN) return BOOLEAN;
--  function "?<" (anonymous, anonymous  : BOOLEAN) return BOOLEAN;
--  function "?<=" (anonymous, anonymous : BOOLEAN) return BOOLEAN;
--  function "?>" (anonymous, anonymous  : BOOLEAN) return BOOLEAN;
--  function "?>=" (anonymous, anonymous : BOOLEAN) return BOOLEAN;

--  function MINIMUM (L, R : BOOLEAN) return BOOLEAN;
--  function MAXIMUM (L, R : BOOLEAN) return BOOLEAN;

--  function RISING_EDGE (signal S  : BOOLEAN) return BOOLEAN;
--  function FALLING_EDGE (signal S : BOOLEAN) return BOOLEAN;

--  function "?=" (anonymous, anonymous  : BIT) return BIT;
--  function "?/=" (anonymous, anonymous : BIT) return BIT;
--  function "?<" (anonymous, anonymous  : BIT) return BIT;
--  function "?<=" (anonymous, anonymous : BIT) return BIT;
--  function "?>" (anonymous, anonymous  : BIT) return BIT;
--  function "?>=" (anonymous, anonymous : BIT) return BIT;

--  function MINIMUM (L, R : BIT) return BIT;
--  function MAXIMUM (L, R : BIT) return BIT;

--  function "??" (anonymous : BIT) return BOOLEAN;

--  function RISING_EDGE (signal S  : BIT) return BOOLEAN;
--  function FALLING_EDGE (signal S : BIT) return BOOLEAN;

--  function MINIMUM (L, R : CHARACTER) return CHARACTER;
--  function MAXIMUM (L, R : CHARACTER) return CHARACTER;

--  function MINIMUM (L, R : SEVERITY_LEVEL) return SEVERITY_LEVEL;
--  function MAXIMUM (L, R : SEVERITY_LEVEL) return SEVERITY_LEVEL;

--  function MINIMUM (L, R : INTEGER) return INTEGER;
--  function MAXIMUM (L, R : INTEGER) return INTEGER;

--  function MINIMUM (L, R : REAL) return REAL;
--  function MAXIMUM (L, R : REAL) return REAL;

--  function "mod" (anonymous, anonymous : TIME) return TIME;
--  function "rem" (anonymous, anonymous : TIME) return TIME;

--  function MINIMUM (L, R : TIME) return TIME;
--  function MAXIMUM (L, R : TIME) return TIME;

--  function MINIMUM (L, R : STRING) return STRING;
--  function MAXIMUM (L, R : STRING) return STRING;

--  function MINIMUM (L : STRING) return CHARACTER;
--  function MAXIMUM (L : STRING) return CHARACTER;

  type BOOLEAN_VECTOR is array (NATURAL range <>) of BOOLEAN;

  -- The predefined operations for this type are as follows:

--  function "and" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function "or" (anonymous, anonymous   : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function "nand" (anonymous, anonymous : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function "nor" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function "xor" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function "xnor" (anonymous, anonymous : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;

--  function "not" (anonymous : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;

--  function "and" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN)
--    return BOOLEAN_VECTOR;
--  function "and" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;
--  function "or" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN)
--    return BOOLEAN_VECTOR;
--  function "or" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;
--  function "nand" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN)
--    return BOOLEAN_VECTOR;
--  function "nand" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;
--  function "nor" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN)
--    return BOOLEAN_VECTOR;
--  function "nor" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;
--  function "xor" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN)
--    return BOOLEAN_VECTOR;
--  function "xor" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;
--  function "xnor" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN)
--    return BOOLEAN_VECTOR;
--  function "xnor" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;

--  function "and" (anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function "or" (anonymous   : BOOLEAN_VECTOR) return BOOLEAN;
--  function "nand" (anonymous : BOOLEAN_VECTOR) return BOOLEAN;
--  function "nor" (anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function "xor" (anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function "xnor" (anonymous : BOOLEAN_VECTOR) return BOOLEAN;

--  function "sll" (anonymous : BOOLEAN_VECTOR; anonymous : INTEGER)
--    return BOOLEAN_VECTOR;
--  function "srl" (anonymous : BOOLEAN_VECTOR; anonymous : INTEGER)
--    return BOOLEAN_VECTOR;
--  function "sla" (anonymous : BOOLEAN_VECTOR; anonymous : INTEGER)
--    return BOOLEAN_VECTOR;
--  function "sra" (anonymous : BOOLEAN_VECTOR; anonymous : INTEGER)
--    return BOOLEAN_VECTOR;
--  function "rol" (anonymous : BOOLEAN_VECTOR; anonymous : INTEGER)
--    return BOOLEAN_VECTOR;
--  function "ror" (anonymous : BOOLEAN_VECTOR; anonymous : INTEGER)
--    return BOOLEAN_VECTOR;

--  function "=" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function "/=" (anonymous, anonymous : BOOLEAN_VECTOR) return BOOLEAN;
--  function "<" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function "<=" (anonymous, anonymous : BOOLEAN_VECTOR) return BOOLEAN;
--  function ">" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function ">=" (anonymous, anonymous : BOOLEAN_VECTOR) return BOOLEAN;

--  function "?=" (anonymous, anonymous  : BOOLEAN_VECTOR) return BOOLEAN;
--  function "?/=" (anonymous, anonymous : BOOLEAN_VECTOR) return BOOLEAN;

--  function "&" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN_VECTOR)
--    return BOOLEAN_VECTOR;
--  function "&" (anonymous : BOOLEAN_VECTOR; anonymous : BOOLEAN) return BOOLEAN_VECTOR;
--  function "&" (anonymous : BOOLEAN; anonymous : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function "&" (anonymous : BOOLEAN; anonymous : BOOLEAN) return BOOLEAN_VECTOR;

--  function MINIMUM (L, R : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;
--  function MAXIMUM (L, R : BOOLEAN_VECTOR) return BOOLEAN_VECTOR;

--  function MINIMUM (L : BOOLEAN_VECTOR) return BOOLEAN;
--  function MAXIMUM (L : BOOLEAN_VECTOR) return BOOLEAN;

--  function "and" (anonymous  : BIT_VECTOR; anonymous : BIT) return BIT_VECTOR;
--  function "and" (anonymous  : BIT; anonymous : BIT_VECTOR) return BIT_VECTOR;
--  function "or" (anonymous   : BIT_VECTOR; anonymous : BIT) return BIT_VECTOR;
--  function "or" (anonymous   : BIT; anonymous : BIT_VECTOR) return BIT_VECTOR;
--  function "nand" (anonymous : BIT_VECTOR; anonymous : BIT) return BIT_VECTOR;
--  function "nand" (anonymous : BIT; anonymous : BIT_VECTOR) return BIT_VECTOR;
--  function "nor" (anonymous  : BIT_VECTOR; anonymous : BIT) return BIT_VECTOR;
--  function "nor" (anonymous  : BIT; anonymous : BIT_VECTOR) return BIT_VECTOR;
--  function "xor" (anonymous  : BIT_VECTOR; anonymous : BIT) return BIT_VECTOR;
--  function "xor" (anonymous  : BIT; anonymous : BIT_VECTOR) return BIT_VECTOR;
--  function "xnor" (anonymous : BIT_VECTOR; anonymous : BIT) return BIT_VECTOR;
--  function "xnor" (anonymous : BIT; anonymous : BIT_VECTOR) return BIT_VECTOR;

--  function "and" (anonymous  : BIT_VECTOR) return BIT;
--  function "or" (anonymous   : BIT_VECTOR) return BIT;
--  function "nand" (anonymous : BIT_VECTOR) return BIT;
--  function "nor" (anonymous  : BIT_VECTOR) return BIT;
--  function "xor" (anonymous  : BIT_VECTOR) return BIT;
--  function "xnor" (anonymous : BIT_VECTOR) return BIT;

--  function "?=" (anonymous, anonymous  : BIT_VECTOR) return BIT;
--  function "?/=" (anonymous, anonymous : BIT_VECTOR) return BIT;

--  function MINIMUM (L, R : BIT_VECTOR) return BIT_VECTOR;
--  function MAXIMUM (L, R : BIT_VECTOR) return BIT_VECTOR;

--  function MINIMUM (L : BIT_VECTOR) return BIT;
--  function MAXIMUM (L : BIT_VECTOR) return BIT;

--  function TO_STRING (VALUE : BIT_VECTOR) return STRING;

--  alias TO_BSTRING is TO_STRING [BIT_VECTOR return STRING];
--  alias TO_BINARY_STRING is TO_STRING [BIT_VECTOR return STRING];
--  function TO_OSTRING (VALUE : BIT_VECTOR) return STRING;
--  alias TO_OCTAL_STRING is TO_OSTRING [BIT_VECTOR return STRING];
--  function TO_HSTRING (VALUE : BIT_VECTOR) return STRING;
--  alias TO_HEX_STRING is TO_HSTRING [BIT_VECTOR return STRING];

  type INTEGER_VECTOR is array (NATURAL range <>) of INTEGER;

  -- The predefined operations for this type are as follows:
--  function "=" (anonymous, anonymous  : INTEGER_VECTOR) return BOOLEAN;
--  function "/=" (anonymous, anonymous : INTEGER_VECTOR) return BOOLEAN;
--  function "<" (anonymous, anonymous  : INTEGER_VECTOR) return BOOLEAN;
--  function "<=" (anonymous, anonymous : INTEGER_VECTOR) return BOOLEAN;
--  function ">" (anonymous, anonymous  : INTEGER_VECTOR) return BOOLEAN;
--  function ">=" (anonymous, anonymous : INTEGER_VECTOR) return BOOLEAN;

--  function "&" (anonymous : INTEGER_VECTOR; anonymous : INTEGER_VECTOR)
--    return INTEGER_VECTOR;
--  function "&" (anonymous : INTEGER_VECTOR; anonymous : INTEGER) return INTEGER_VECTOR;
--  function "&" (anonymous : INTEGER; anonymous : INTEGER_VECTOR) return INTEGER_VECTOR;
--  function "&" (anonymous : INTEGER; anonymous : INTEGER) return INTEGER_VECTOR;

--  function MINIMUM (L, R : INTEGER_VECTOR) return INTEGER_VECTOR;
--  function MAXIMUM (L, R : INTEGER_VECTOR) return INTEGER_VECTOR;

--  function MINIMUM (L : INTEGER_VECTOR) return INTEGER;
--  function MAXIMUM (L : INTEGER_VECTOR) return INTEGER;

  type REAL_VECTOR is array (NATURAL range <>) of REAL;

  -- The predefined operations for this type are as follows:
--  function "=" (anonymous, anonymous  : REAL_VECTOR) return BOOLEAN;
--  function "/=" (anonymous, anonymous : REAL_VECTOR) return BOOLEAN;
--  function "<" (anonymous, anonymous  : REAL_VECTOR) return BOOLEAN;
--  function "<=" (anonymous, anonymous : REAL_VECTOR) return BOOLEAN;
--  function ">" (anonymous, anonymous  : REAL_VECTOR) return BOOLEAN;
--  function ">=" (anonymous, anonymous : REAL_VECTOR) return BOOLEAN;

--  function "&" (anonymous : REAL_VECTOR; anonymous : REAL_VECTOR)
--    return REAL_VECTOR;
--  function "&" (anonymous : REAL_VECTOR; anonymous : REAL) return REAL_VECTOR;
--  function "&" (anonymous : REAL; anonymous : REAL_VECTOR) return REAL_VECTOR;
--  function "&" (anonymous : REAL; anonymous : REAL) return REAL_VECTOR;

--  function MINIMUM (L, R : REAL_VECTOR) return REAL_VECTOR;
--  function MAXIMUM (L, R : REAL_VECTOR) return REAL_VECTOR;

--  function MINIMUM (L : REAL_VECTOR) return REAL;
--  function MAXIMUM (L : REAL_VECTOR) return REAL;

  type TIME_VECTOR is array (NATURAL range <>) of TIME;

  -- The predefined operations for this type are as follows:
--  function "=" (anonymous, anonymous  : TIME_VECTOR) return BOOLEAN;
--  function "/=" (anonymous, anonymous : TIME_VECTOR) return BOOLEAN;
--  function "<" (anonymous, anonymous  : TIME_VECTOR) return BOOLEAN;
--  function "<=" (anonymous, anonymous : TIME_VECTOR) return BOOLEAN;
--  function ">" (anonymous, anonymous  : TIME_VECTOR) return BOOLEAN;
--  function ">=" (anonymous, anonymous : TIME_VECTOR) return BOOLEAN;

--  function "&" (anonymous : TIME_VECTOR; anonymous : TIME_VECTOR)
--    return TIME_VECTOR;
--  function "&" (anonymous : TIME_VECTOR; anonymous : TIME) return TIME_VECTOR;
--  function "&" (anonymous : TIME; anonymous : TIME_VECTOR) return TIME_VECTOR;
--  function "&" (anonymous : TIME; anonymous : TIME) return TIME_VECTOR;

--  function MINIMUM (L, R : TIME_VECTOR) return TIME_VECTOR;
--  function MAXIMUM (L, R : TIME_VECTOR) return TIME_VECTOR;

--  function MINIMUM (L : TIME_VECTOR) return TIME;
--  function MAXIMUM (L : TIME_VECTOR) return TIME;

--  function MINIMUM (L, R : FILE_OPEN_KIND) return FILE_OPEN_KIND;
--  function MAXIMUM (L, R : FILE_OPEN_KIND) return FILE_OPEN_KIND;

--  function MINIMUM (L, R : FILE_OPEN_STATUS) return FILE_OPEN_STATUS;
--  function MAXIMUM (L, R : FILE_OPEN_STATUS) return FILE_OPEN_STATUS;

  -- predefined TO_STRING operations on scalar types
--  function TO_STRING (VALUE : BOOLEAN) return STRING;
--  function TO_STRING (VALUE : BIT) return STRING;
--  function TO_STRING (VALUE : CHARACTER) return STRING;
--  function TO_STRING (VALUE : SEVERITY_LEVEL) return STRING;
--  function TO_STRING (VALUE : INTEGER) return STRING;
--  function TO_STRING (VALUE : REAL) return STRING;
--  function TO_STRING (VALUE : TIME) return STRING;
--  function TO_STRING (VALUE : FILE_OPEN_KIND) return STRING;
--  function TO_STRING (VALUE : FILE_OPEN_STATUS) return STRING;

  -- predefined overloaded TO_STRING operations
--  function TO_STRING (VALUE : REAL; DIGITS : NATURAL) return STRING;
--  function TO_STRING (VALUE : REAL; FORMAT : STRING) return STRING;
--  function TO_STRING (VALUE : TIME; UNIT : TIME) return STRING;
end package standard_additions;

